#!/usr/bin/perl 
# FIPS-SetDiscardAcq.pl
# $Id: FIPS-SetDiscardAcq.pl,v 1.2 2006/06/29 23:03:19 rnotestine Exp $
#################################################################################
# Sets the number of discarded acquisitions (discardAcq) in the fips-process.xml file
#
# Dependencies:
#		XML::XPath - SRB@/home/dkeator@uci-bic/NonHumanPhantomScript/XML
#
# Authors: 	David Keator (dbkeator@uci.edu)
#		Syam Gadde (gadde@biac.duke.edu)
#               Doug Greve (greve@nmr.mgh.harvard.edu)
#		
# Revision History: Modification of XMLFuncs.pl 
###############################################################################

use FindBin qw($RealDir);
use lib "$RealDir";
require 'FIPS-XMLFuncs.pl';

my $nargs = $#ARGV + 1;
if($nargs != 3) {
    print "FIPS-SetDiscardAcq xmlin xmlout ndiscard\n";
    exit(1);
}

my $xml_in   = shift @ARGV;
my $xml_out  = shift @ARGV;
my $ndiscard = shift @ARGV;

if(! -e $xml_in ) {
  print "ERROR: input xml file $xml_in does not exist.\n";
  exit(1);
}


#############################################################################
# Standard Stuff to read in an XML document
#############################################################################
my $parser = new XML::DOM::Parser;
my $doc = $parser->parsefile("$xml_in");
my $root_node = $doc->getDocumentElement();

# Change the number of discarded acqusitions
setValue($doc,"FIPS//series[0]//discardAcq",$ndiscard);
$doc->printToFile($xml_out);

$doc->dispose; # Avoid memory leaks - cleanup circular references

exit(0);
