#! /usr/bin/perl

use SOAP::Lite;

##############################################################################################
#
#  Takes three arguments, the experiment name, the subject's birn ID, and the demographic item 
#  you are interested in. 
#
##############################################################################################
#
#  Example of phaseII Demographics available:  
#   Race: NIH Scale 1-5
#   Ethnicity
#   Education
#   Mother's Education
#   Father's Education
#   Occupation
#   Mother's Occupation
#   Father's Occupation
#   Age
#   Marital Status
#   Living Arrangement
#   Number of Children
#   Gender
#   Handedness
#
# Example list of UNM site fBIRN phaseII subjects:
#  001005725953
#  001009914240
#  001012126889
#  001015956739
#  001017196728
#  001020948255
#  001021160062
#  001025290760
#  001025550152
#  001025797909
#  001029291693
#  001029798240
#  001037881059
#  001038889530
#  001044385032
#  001046143247
#  001050720368
#  001053294261
#  001059709071
#  001063297025
#  001071071414
#  001071753990
#  001074909456
#  001083789439
#  001084262659
#  001091728827
#  001094450869
#  001096709026
#  001012753423
#  001039068210
#  001000000103
#  001000000104
#  001000000105
#  001000000106
#  001028614244

if($#ARGV < 2){
    print "\n\nUsage: ./example_client.pl experiment birn_id item\n\n";
    exit;
}

$experiment = $ARGV[0];
$birn_id = $ARGV[1];
$item = $ARGV[2];

#$experiment = "fBIRNPhaseII__0010";
#$birn_id = "001096709026";
#$item = "Handedness";

my $web_service = SOAP::Lite
    -> uri('Demographics')
    -> proxy('http://64.234.191.20:8080/webservices/services/Demographics')
    -> getDemographic(
	    SOAP::Data->type('string')->name('in0' => $experiment),
            SOAP::Data->type('string')->name('in1' => $birn_id),
            SOAP::Data->type('string')->name('in2' => $item),
       );

unless($web_service->fault){
    my $result = $web_service->result;

    print "\n\n$item: $result\n\n";
    exit(0);
}
else{
    print "\n\nSoap Error: " . $web_service->faultstring . "\n\n";
    exit(1);
}

