#!/usr/bin/perl 
# $Id: fips-locate.pl,v 1.14 2007/10/09 22:00:30 dgreve Exp $

# How to source fipsrc
# Exact matches
# Sort by
# Print only
# Output - txt, html, run browser.

use strict;

#--------------------------------------------------------------#
sub checknargs {
    my ($nargsleft,$nargsneeded,$flag) = @_;
    if($nargsleft == $nargsneeded - 2){
	print "ERROR: flag $flag needs $nargsneeded arguments.\n";
	exit 1;
    }
    return;
}
#--------------------------------------------------------------#
sub SortByAnaName {
    my @aline = split(" ",$a);
    my @bline = split(" ",$b);
    my $c = $aline[13] cmp $bline[13];
    return $c;
}
#--------------------------------------------------------------#
sub SortByBIRNId {
    my @aline = split(" ",$a);
    my @bline = split(" ",$b);
    my $c = $aline[1] cmp $bline[1];
    return $c;
}


#--------------------------------------------------------------#
# main --------------------------------------------------------#
#--------------------------------------------------------------#

# fips-locate.pl this "[\w]hos"
# $_ = $ARGV[0];
# my $mtch = $ARGV[1];
# print "$_  $mtch\n";
# my $tst = length(m/$mtch/g);
# print "$tst\n";
# exit 1;

my $version = "\$Id\$";
my $BIRNIdRE = ();
my $RecSiteRE = ();
my $AcqSiteRE = ();
my $ProjectRE = ();
my $StudyNameRE = ();
my $StudyIdRE = ();
my $VisitNameRE = ();
my $VisitIdRE = ();
my $RunTypeRE = ();
my $ParadigmRE = ();
my $RunNoRE = ();
my $AnalysisLevelRE = ();
my $AnalysisNameRE = ();
my $ErrorStatusRE = ();
my $IsRunningRE = ();
my $XMLDirRE = ();
my $Exact = 0;

my $htmlfile = "/tmp/fips.html";
my $sortby = "AnalysisName";
my $browsercmd = "firefox";
my $DoHTML = 0;

if($#ARGV == -1) {
  print "fips-locate.pl\n" ;
  print "  --project projectname (eg, fBIRNPhaseII). [--pr]\n" ;
  print "    --ts : set projectname to FBIRNSubject2007TE\n" ;
  print "    --cc : set projectname to FBIRNCoilComparison\n" ;
  print "  --birnid birnid  (eg, 000303269784) [--bid]\n" ;
  print "  --siteid siteid  (eg, 0006) [--site] \n" ;
  print "  --visitname visitname [--vn]\n" ;
  print "  --visitid   visitid [--vid]\n" ;
  print "  --studyname studyname [--sn]\n" ;
  print "  --studyid   studyid [--sid]\n" ;
  print "  --paradigm paradigm (eg,sensory_motor)  [--pa]\n" ;
  print "  --runtype  runtype (eg, functional) [--rt]\n" ;
  print "  --analysislevel level (eg, none, FirstLevel, FFx) [--al]\n" ;
  print "  --analysisname name (eg, NIFTI,  sirp-hp65-stc-to7-gam.flac) [--an]\n" ;
  print "  --flac name : sets analysislevel to FirstLevel and analysisname to name\n" ;
  print "  --error : ErrorStatus = 1" ;
  print "  --noerror : ErrorStatus = 0" ;
  print "  --isrunning (or --is-running)";
  print "  --isnotrunning (or --is-not-running)" ;
  print "  \n" ;
  print "  --exact : require an exact match (flac only)\n" ;
  print "  --browser browsercmd \n" ;
  print "  --html \n" ;
  exit 1;
}

# Parse the command-line
my $inarg;
while($#ARGV != -1){
    $inarg = shift @ARGV;
    #print "inarg: $inarg, $#ARGV\n";
    if($inarg eq "--project" || $inarg eq "--pr" || $inarg eq "--projectname") {
	checknargs($#ARGV,1,$inarg);
	$ProjectRE = shift @ARGV;
    } elsif($inarg eq "--ts") {
	$ProjectRE = "FBIRNSubject2007TE";
    } elsif($inarg eq "--cc") {
	$ProjectRE = "FBIRNCoilComparison";
    } elsif($inarg eq "--birnid" || $inarg eq "--bid") {
	checknargs($#ARGV,1,$inarg);
	$BIRNIdRE = shift @ARGV;
    } elsif($inarg eq "--siteid" || $inarg eq "--site") {
	checknargs($#ARGV,1,$inarg);
	$AcqSiteRE = shift @ARGV;
    } elsif($inarg eq "--visitname" || $inarg eq "--vn") {
	checknargs($#ARGV,1,$inarg);
	$VisitNameRE = shift @ARGV;
    } elsif($inarg eq "--visitid" || $inarg eq "--vid") {
	checknargs($#ARGV,1,$inarg);
	$VisitIdRE = shift @ARGV;
    } elsif($inarg eq "--studyname" || $inarg eq "--sn") {
	checknargs($#ARGV,1,$inarg);
	$StudyNameRE = shift @ARGV;
    } elsif($inarg eq "--studyid" || $inarg eq "--sid") {
	checknargs($#ARGV,1,$inarg);
	$StudyIdRE = shift @ARGV;
    } elsif($inarg eq "--paradigm" || $inarg eq "--pa") {
	checknargs($#ARGV,1,$inarg);
	$ParadigmRE = shift @ARGV;
    } elsif($inarg eq "--runtype" || $inarg eq "--rt") {
	checknargs($#ARGV,1,$inarg);
	$RunTypeRE = shift @ARGV;
    } elsif($inarg eq "--analysislevel" || $inarg eq "--al") {
	checknargs($#ARGV,1,$inarg);
	$AnalysisLevelRE = shift @ARGV;
    } elsif($inarg eq "--analysisname" || $inarg eq "--an") {
	checknargs($#ARGV,1,$inarg);
	$AnalysisNameRE = shift @ARGV;
    } elsif($inarg eq "--error") {
	checknargs($#ARGV,1,$inarg);
	$ErrorStatusRE = 1;
    } elsif($inarg eq "--no-error" || $inarg eq "--noerror") {
	checknargs($#ARGV,1,$inarg);
	$ErrorStatusRE = 0;
    } elsif($inarg eq "--is-running" || $inarg eq "--isrunning") {
	$IsRunningRE = 1;
    } elsif($inarg eq "--is-not-running" || $inarg eq "--isnotrunning") {
	$IsRunningRE = 0;
    } elsif($inarg eq "--flac") {
	checknargs($#ARGV,1,$inarg);
	$AnalysisNameRE = shift @ARGV;
	$AnalysisLevelRE = "FirstLevel";
    } elsif($inarg eq "--sortby") {
	checknargs($#ARGV,1,$inarg);
	$sortby = shift @ARGV;
    } elsif($inarg eq "--browser") {
	checknargs($#ARGV,1,$inarg);
	$browsercmd = shift @ARGV;
	$DoHTML = 1;
    } elsif($inarg eq "--exact") {
	$Exact = 1;
    } elsif($inarg eq "--html") {
	$DoHTML = 1;
    } elsif($inarg eq "--no-html") {
	$DoHTML = 0;
    } else {
	print "ERROR: flag $inarg unrecognized\n";
	exit 1;
    }
}

# Open the database
my $dbfile = "$ENV{FIPS_DB_DIR}/fips.database.dat";
open(DB, $dbfile) || die("Couldn't open $dbfile.");
my @lines = <DB>;
close(DB);

my $line;
my @items;
my $item;
my @newlist = ();
foreach $line (@lines) {
    @items = split(" ",$line);
    $item = $items[0];
    if($item eq "#") {next;} # Skip lines that begin with '#'
    my($Nth,$BIRNId,$RecSite,$AcqSite,$Project,$StudyName,$StudyId,
       $VisitName,$VisitId,$VisitDate,$RunType,$Paradigm,$RunNo,$AnalysisLevel,
       $AnalysisName,$AnalysisDate,$AnalysisTime,$ErrorStatus,$IsRunning,$XMLDir) = @items;

    if(length($BIRNIdRE) != 0){
	$_ = $BIRNId;
	my $tst = length(m/$BIRNIdRE/gi);
	if(! $tst) { next;}
    }
    if(length($RecSiteRE) != 0){
	$_ = $RecSite;
	my $tst = length(m/$RecSiteRE/gi);
	if(! $tst) { next;}
    }
    if(length($AcqSiteRE) != 0){
	$_ = $AcqSite;
	my $tst = length(m/$AcqSiteRE/gi);
	if(! $tst) { next;}
    }
    if(length($ProjectRE) != 0){
	$_ = $Project;
	my $tst = length(m/$ProjectRE/gi);
	if(! $tst) { next;}
    }
    if(length($StudyNameRE) != 0){
	$_ = $StudyName;
	my $tst = length(m/$StudyNameRE/gi);
	if(! $tst) { next;}
    }
    if(length($StudyIdRE) != 0){
	$_ = $StudyId;
	my $tst = length(m/$StudyIdRE/gi);
	if(! $tst) { next;}
    }
    if(length($VisitNameRE) != 0){
	$_ = $VisitName;
	my $tst = length(m/$VisitNameRE/gi);
	if(! $tst) { next;}
    }
    if(length($VisitIdRE) != 0){
	$_ = $VisitId;
	my $tst = length(m/$VisitIdRE/gi);
	if(! $tst) { next;}
    }
    if(length($RunTypeRE) != 0){
	$_ = $RunType;
	my $tst = length(m/$RunTypeRE/gi);
	if(! $tst) { next;}
    }
    if(length($ParadigmRE) != 0){
	$_ = $Paradigm;
	my $tst = length(m/$ParadigmRE/gi);
	if(! $tst) { next;}
    }
    if(length($RunNoRE) != 0){
	$_ = $RunNo;
	my $tst = length(m/$RunNoRE/gi);
	if(! $tst) { next;}
    }
    if(length($AnalysisLevelRE) != 0){
	$_ = $AnalysisLevel;
	my $tst = length(m/$AnalysisLevelRE/gi);
	if(! $tst) { next;}
    }
    if(length($AnalysisNameRE) != 0){
      $_ = $AnalysisName;
      if($Exact && (! ($AnalysisNameRE eq $_) ) ) {next;}
      my $tst = length(m/$AnalysisNameRE/gi);
      if(! $tst) { next;}
    }
    if(length($ErrorStatusRE) != 0){
      if($ErrorStatusRE != $ErrorStatus) {next;}
    }
    if(length($IsRunningRE) != 0){
      if($IsRunningRE != $IsRunning) {next;}
    }
    $newlist[$#newlist+1] = $line;
}

#------------------ Count number of matches -------
my $nmatches = $#newlist + 1;
#print("Found $nmatches matches\n");
if($nmatches == 0) {
    print("Did not find any matches\n");
    exit(1);
}

#------------------ Sort -------------------------
#print("sortby = $sortby\n");
if($sortby eq "AnalysisName") {
    my @newlist = sort SortByAnaName @newlist;
} elsif ($sortby eq "BIRNId") {
    my @newlist = sort SortByBIRNId @newlist;
} else {
    print("ERROR: sortby $sortby not recognized\n");
    exit(1);
}

# Create html file
open(fp, '>',$htmlfile) || die("Couldn't open the $htmlfile");
print fp "<html>";
print fp "<TITLE> FIPS Database </TITLE>";
print fp "<center><h1> FIPS Database </h1></center>";
print fp "For more information about FIPS and fBIRN see the FIPS <a href=http://132.239.132.249:8080/xwiki/bin/view/Project-FIPS-Public/Home> Wiki.</a>";
print fp "<table cellpadding=2 cellspacing=2 border=1 style=text-align: left; width: 100%;>";
print fp "<tbody>";
print fp "<tr>";
print fp "<td> Nth </td>";
print fp "<td> BIRNId </td>";
print fp "<td> Site </td>";
print fp "<td> Vis </td>";
print fp "<td> Date </td>";
print fp "<td> Paradigm </td>";
print fp "<td> Run </td>";
print fp "<td> AnaLevel </td>";
print fp "<td> Analysis </td>";
print fp "<td> Unix Path </td>";
print fp "</tr>";

my $xmlfile;
my $scandate;
my $report;
my $BIRNIdPrev;
my $AcqSitePrev;
my $color = "#009900";
my $Mth = 0;
foreach $line (@newlist) {
    $Mth++;
    @items = split(" ",$line);
    my($Nth,$BIRNId,$RecSite,$AcqSite,$Project,$StudyName,$StudyId,
       $VisitName,$VisitId,$VisitDate,$RunType,$Paradigm,$RunNo,
       $AnalysisLevel, $AnalysisName,$AnalysisDate,$AnalysisTime,
       $ErrorStatus,$IsRunning,$XMLDir) = @items;

    if($Mth == 1) { $BIRNIdPrev = $BIRNId; }
    if(!($BIRNId eq $BIRNIdPrev) || !($AcqSite eq $AcqSitePrev)) {
      if($color eq "#009900") { $color = "#000000";}
      else { $color = "#009900"};
      $BIRNIdPrev = $BIRNId;
      $AcqSitePrev = $AcqSite;
    }

    #print "$BIRNId $Project $Paradigm $AnalysisName\n";
    print "$XMLDir\n";

    $xmlfile = $XMLDir;
    $xmlfile .= "/fips-process.xml";
    if(-e $xmlfile) {
	open(xfp,"GetVisitDate.pl --xml $xmlfile|") ||
	    die "ERROR: GetVisitDate.pl \n";
	$scandate = <xfp>;
	close(xfp);
	#chomp($scandate);
    }
    else {$scandate = "unkown";}
    #print "$scandate";

    $report = $XMLDir;
    $report .= "/fips-report.html";
    if(! (-e $report) ){
      $report = $XMLDir;
      $report .= "/report.html";
    }

    print fp "\n";
    #print fp "\<font color=\"$color\">\n";
    print fp "<tr>";
    print fp "<td> $Mth </td>";
    print fp "<td> \<font color=\"$color\"> $BIRNId </font> </td>";
    print fp "<td> \<font color=\"$color\"> $AcqSite </font> </td>";
    print fp "<td> \<font color=\"$color\"> $VisitId </font> </td>";
    print fp "<td> \<font color=\"$color\"> $scandate </font> </td>";
    print fp "<td> \<font color=\"$color\"> $Paradigm </font> </td>";
    print fp "<td> \<font color=\"$color\"> $RunNo </font> </td>";
    print fp "<td> \<font color=\"$color\"> $AnalysisLevel </font> </td>";
    print fp "<td> \<font color=\"$color\"> $AnalysisName </font> </td>";
    #print fp "</font>  \</td\>\n";

    if(-e $report){
      print fp "<td> <a href = \"file:$report\"> report </a> </td>";
    }
    else {
      print fp "<td> <a href=\"file:$XMLDir\"> <font color=\"#FF0000\"> dir </font> </a> </td>";
    }
    print fp "</tr>\n";

}

print fp "</tbody>";
print fp "</table>";
print fp "</html>";
close(fp);

if($DoHTML) {
    print "\nLaunching browser.\n\n";
    exec("$browsercmd $htmlfile&");
#exec("konqueror $htmlfile&");
}

exit 1;

