#!/usr/bin/python
# docs.python.org/lib/module-xml.dom.html
# pyxml.sourceforge.net/topics/howto/xml-howto.html
#
"""
FIPS XML and Databasing operations
"""
import sys;
import os;
import os.path;
import xml.dom;
from xml.dom.ext.reader import Sax2
from xml.dom.ext import PrettyPrint;
#from xml     import createDocument;
#from xml.dom.minidom import Document;

# FUNCTION --------------------------------------------------
def findfpxml(top,xmllist):
  """
  findfpxml(top,xmllist) - returns list of paths of fips-process.xml
  under top. Follows symlinks recursively.
  """
  for (root, dirs, files) in os.walk(top):

    # Go through each file
    for f in files:
      if(f == "fips-process.xml"):
        # If this file is fips-process.xml, construct full
        # path name and append to list
        fpath = os.path.join(root, f);
        xmllist.append(fpath);
        #print "%s" % (fpath);
      #endif
    #end for f

    # Go through each directory, recursive for symlinks
    for d in dirs:
      dpath = os.path.join(root, d);
      if(os.path.islink(dpath)):
        #print "recursive %s" % dpath;
        xmllist = findfpxml(dpath,xmllist);
      #endif
    #end for d

  #end for walk
  return xmllist;
#end function findfpxml(top,xmllist):

#------------------ main ----------------------------
if __name__ == '__main__':
  top = sys.argv[1];
  reader = Sax2.Reader();

  if(os.environ.get('FIPS_HOME',0) == 0):
    print "ERROR:  FIPS_HOME not defined";
    sys.exit(1);
  #endif  
  FIPS_HOME = os.environ['FIPS_HOME'];

  fipsdbfile = os.path.join(FIPS_HOME,"fipsdb.xml");
  impl   = xml.dom.getDOMImplementation();
  fipsdb = impl.createDocument(None,"FIPSDB",None);
  fipsdbroot = fipsdb.documentElement;

  print "Searching for fips-process.xml files";
  (ut, st, cut, cst, et0) = os.times();
  xmllist = findfpxml(top,[]);
  (ut, st, cut, cst, et) = os.times();
  dt = et-et0;
  print "Found %d xml files in %g sec" % (len(xmllist),dt);

  print "Loading xml files";
  (ut, st, cut, cst, et0) = os.times();
  xmldomlist = [];
  nth = 1;
  for xmlfile in xmllist:
    if(nth % 100 == 1):
      (ut, st, cut, cst, et) = os.times();
      dt = et-et0;
      #print "%d/%d %g %s" % (nth,len(xmllist),dt,xmlfile);
      print "%d/%d %g" % (nth,len(xmllist),dt);
    #endif  
    fipsprocdoc = reader.fromStream(xmlfile);
    fipsproc    = fipsprocdoc.getElementsByTagName("FIPS")[0];

    xmlpath    = fipsprocdoc.createElement("xmlpath");
    tmp = os.path.join(os.getcwd(),xmlfile);
    xmlpathtxt = fipsprocdoc.createTextNode(tmp);
    xmlpath.appendChild(xmlpathtxt);
    fipsproc.appendChild(xmlpath);
    
    x = fipsdb.importNode(fipsproc,True);
    fipsdbroot.appendChild(x);
    nth = nth + 1;
  #end for xml

  fp = open(fipsdbfile,'w');
  PrettyPrint(fipsdb,fp);
  fp.close();

  sys.exit(1);

#end if main 
