
qastruct = LoadQASum('qa.dat');
qatable0 = qastruct.qatable;
birnids = qastruct.birnids;
visitdates = qastruct.visitdates;
acqsites = qastruct.acqsites;
visitnos = qastruct.visitnos;
runnos = qastruct.runnos;
measnames = qastruct.measnames;

% Resort all so that they are in order of increasing fsnr
[qatable ind] = sortrows(qatable0,4);
birnids = birnids(ind,:);
visitdates = visitdates(ind,:);
acqsites = acqsites(ind,:);
visitnos = visitnos(ind,:);
runnos   = runnos(ind,:);


indDuke = strmatch('0003',acqsites); 
indBWH  = strmatch('0005',acqsites); 
indMGH  = strmatch('0006',acqsites); 
indYale = strmatch('0018',acqsites); 

nDuke = length(indDuke);
nBWH = length(indBWH);
nMGH = length(indMGH);
nYale = length(indYale);

nth = 0;
for nthmeas = [1 2 4 5 6 7]
  nth = nth + 1;
  meas = qatable(:,nthmeas);
  figure(nth);
  plot(1:nDuke,sort(meas(indDuke)),...
       1:nBWH,sort(meas(indBWH)),...
       1:nMGH,sort(meas(indMGH)),...
       1:nYale,sort(meas(indYale)) );
  xlabel('Sort Number');
  title(deblank(measnames(nthmeas,:)));
  legend('Duke','BWH','MGH','Yale',4);
  set(gcf,'color',[1 1 1]);
end



clear p x;
clear measmn measstd;
for site = 1:4
  if(site == 1) ind = indDuke; end
  if(site == 2) ind = indBWH; end
  if(site == 3) ind = indMGH; end
  if(site == 4) ind = indYale; end

  nmask = qatable(ind,3);
  [hh xx] = hist(nmask,10);
  p(site,:) = hh/length(ind);
  x(site,:) = xx;

  measmn(site,:)  = mean(qatable(ind,:));
  measstd(site,:) = std(qatable(ind,:));
  
end




